[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Diff for /openbsd/fw_update/fw_install.sh between version 1.14 and 1.141

version 1.14, 2021/10/17 23:25:14 version 1.141, 2022/01/06 16:38:24
Line 1 
Line 1 
 #!/bin/ksh  #!/bin/ksh
 set -e  #       $OpenBSD$
   #
   # Copyright (c) 2021 Andrew Hewus Fresh <afresh1@openbsd.org>
   #
   # Permission to use, copy, modify, and distribute this software for any
   # purpose with or without fee is hereby granted, provided that the above
   # copyright notice and this permission notice appear in all copies.
   #
   # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
   # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
   # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
   # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
   # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
   # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
   # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   
 scan_dmesg() {  set -o errexit -o pipefail -o nounset -o noclobber -o noglob
         # no bsort for now  set +o monitor
         sed -n "$1" /var/run/dmesg.boot  export PATH=/usr/bin:/bin:/usr/sbin:/sbin
   
   CFILE=SHA256.sig
   DESTDIR=${DESTDIR:-}
   FWPATTERNS="${DESTDIR}/usr/share/misc/firmware_patterns"
   
   VNAME=${VNAME:-$(sysctl -n kern.osrelease)}
   VERSION=${VERSION:-"${VNAME%.*}${VNAME#*.}"}
   
   HTTP_FWDIR="$VNAME"
   VTYPE=$( sed -n "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p" \
       /var/run/dmesg.boot | sed '$!d' )
   [[ $VTYPE == -!(stable) ]] && HTTP_FWDIR=snapshots
   
   FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
   FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
   
   DRYRUN=false
   VERBOSE=0
   DELETE=false
   DOWNLOAD=true
   INSTALL=true
   LOCALSRC=
   
   unset FTPPID
   unset FWPKGTMP
   REMOVE_LOCALSRC=false
   cleanup() {
           set +o errexit # ignore errors from killing ftp
           [ "${FTPPID:-}" ] && kill -TERM -"$FTPPID" 2>/dev/null
           [ "${FWPKGTMP:-}" ] && rm -rf "$FWPKGTMP"
           "$REMOVE_LOCALSRC" && rm -rf "$LOCALSRC"
 }  }
   trap cleanup EXIT
   
   tmpdir() {
           local _i=1 _dir
   
           # If we're not in the installer,
           # we have mktemp and a more hostile environment.
           if [ -x /usr/bin/mktemp ]; then
                   _dir=$( mktemp -d "${1}-XXXXXXXXX" )
           else
                   until _dir="${1}.$_i.$RANDOM" && mkdir -- "$_dir" 2>/dev/null; do
                       ((++_i < 10000)) || return 1
                   done
           fi
   
           echo "$_dir"
   }
   
   fetch() {
           local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _exit _error=''
   
           # If we're not in the installer,
           # we have su(1) and doas(1) is unlikely to be configured.
           set -o monitor # make sure ftp gets its own process group
           (
           _flags=-vm
           case "$VERBOSE" in
                   0|1) _flags=-VM ;;
                     2) _flags=-Vm ;;
           esac
           if [ -x /usr/bin/su ]; then
                   exec /usr/bin/su -s /bin/ksh "$_user" -c \
                       "/usr/bin/ftp -N '${0##/}' -D 'Get/Verify' $_flags -o- '$_src'" > "$_dst"
           else
                   exec /usr/bin/doas -u "$_user" \
                       /usr/bin/ftp -N "${0##/}" -D 'Get/Verify' $_flags -o- "$_src" > "$_dst"
           fi
           ) & FTPPID=$!
           set +o monitor
   
           SECONDS=0
           _last=0
           while kill -0 -"$FTPPID" 2>/dev/null; do
                   if [[ $SECONDS -gt 12 ]]; then
                           set -- $( ls -ln "$_dst" 2>/dev/null )
                           if [[ $_last -ne $5 ]]; then
                                   _last=$5
                                   SECONDS=0
                                   sleep 1
                           else
                                   kill -INT -"$FTPPID" 2>/dev/null
                                   _error=" (timed out)"
                           fi
                   else
                           sleep 1
                   fi
           done
   
           set +o errexit
           wait "$FTPPID"
           _exit=$?
           set -o errexit
   
           unset FTPPID
   
           if [ "$_exit" -ne 0 ]; then
                   rm -f "$_dst"
                   echo "Cannot fetch $_src$_error" >&2
                   return 1
           fi
   }
   
   verify() {
           # On the installer we don't get sha256 -C, so fake it.
           if ! fgrep -qx "SHA256 (${1##*/}) = $( /bin/sha256 -qb "$1" )" "$CFILE"; then
                   echo "Checksum test for ${1##*/} failed." >&2
                   return 1
           fi
   }
   
   firmware_in_dmesg() {
           local _d _m _line _dmesgtail _last='' _nl=$( echo )
   
           # When we're not in the installer, the dmesg.boot can
           # contain multiple boots, so only look in the last one
           _dmesgtail="$( echo ; sed -n 'H;/^OpenBSD/h;${g;p;}' /var/run/dmesg.boot )"
   
           grep -v '^[[:space:]]*#' "$FWPATTERNS" |
               while read -r _d _m; do
                   [ "$_d" = "$_last" ] && continue
                   [ "$_m" ]             || _m="${_nl}${_d}[0-9] at "
                   [ "$_m" = "${_m#^}" ] || _m="${_nl}${_m#^}"
   
                   if [[ $_dmesgtail = *$_m* ]]; then
                           echo "$_d"
                           _last="$_d"
                   fi
               done
   }
   
   firmware_filename() {
           local _f
           _f="$( sed -n "s/.*(\($1-firmware-.*\.tgz\)).*/\1/p" "$CFILE" | sed '$!d' )"
           ! [ "$_f" ] && echo "Unable to find firmware for $1" >&2 && return 1
           echo "$_f"
   }
   
   firmware_devicename() {
           local _d="${1##*/}"
           _d="${_d%-firmware-*}"
           echo "$_d"
   }
   
 installed_firmware() {  installed_firmware() {
         for fw in ${PKGDIR}/$1-firmware*; do          local _pre="$1" _match="$2" _post="$3" _firmware
                 [ -e "$fw" ] || continue          set -sA _firmware -- $(
                 echo ${fw##*/}              set +o noglob
               grep -Fxl '@option firmware' \
                   "${DESTDIR}/var/db/pkg/"$_pre"$_match"$_post"/+CONTENTS" \
                   2>/dev/null || true
               set -o noglob
           )
   
           [ "${_firmware[*]:-}" ] || return 0
           for fw in "${_firmware[@]}"; do
                   fw="${fw%/+CONTENTS}"
                   echo "${fw##*/}"
         done          done
 }  }
   
 # tmpdir, do_as, unpriv, and unpriv2 are from install.sub  detect_firmware() {
           local _devices _last='' _d
   
 # Create a temporary directory based on the supplied directory name prefix.          set -sA _devices -- $(
 tmpdir() {              firmware_in_dmesg
         local _i=1 _dir              for _d in $( installed_firmware '*' '-firmware-' '*' ); do
                   firmware_devicename "$_d"
               done
           )
   
         until _dir="${1?}.$_i.$RANDOM" && mkdir -- "$_dir" 2>/dev/null; do          [ "${_devices[*]:-}" ] || return 0
                 ((++_i < 10000)) || return 1          for _d in "${_devices[@]}"; do
                   [ "$_last" = "$_d" ] && continue
                   echo "$_d"
                   _last="$_d"
         done          done
         echo "$_dir"  
 }  }
   
 # Run a command ($2+) as unprivileged user ($1).  add_firmware () {
 # Take extra care that after "cmd" no "user" processes exist.          local _f="${1##*/}" _m="${2:-Install}" _pkgname
 #          FWPKGTMP="$( tmpdir "${DESTDIR}/var/db/pkg/.firmware" )"
 # Optionally:          local _flags=-vm
 #       - create "file" and chown it to "user"          case "$VERBOSE" in
 #       - after "cmd", chown "file" back to root                  0|1) _flags=-VM ;;
 #                  2|3) _flags=-Vm ;;
 # Usage: do_as user [-f file] cmd          esac
 do_as() {  
         (( $# >= 2 )) || return  
   
         local _file _rc _user=$1          ftp -N "${0##/}" -D "$_m" "$_flags" -o- "file:${1}" |
         shift                  tar -s ",^\+,${FWPKGTMP}/+," \
                       -s ",^firmware,${DESTDIR}/etc/firmware," \
                       -C / -zxphf - "+*" "firmware/*"
   
         if [[ $1 == -f ]]; then          _pkgname="$( sed -n '/^@name /{s///p;q;}' "${FWPKGTMP}/+CONTENTS" )"
                 _file=$2          if [ ! "$_pkgname" ]; then
                 shift 2                  echo "Failed to extract name from $1, partial install" 2>&1
                   rm -rf "$FWPKGTMP"
                   unset FWPKGTMP
                   return 1
         fi          fi
   
         if [[ -n $_file ]]; then          # TODO: Should we mark these so real fw_update can -Drepair?
                 >$_file          ed -s "${FWPKGTMP}/+CONTENTS" <<EOL
                 chown "$_user" "$_file"  /^@comment pkgpath/ -1a
   @option manual-installation
   @option firmware
   @comment install-script
   .
   w
   EOL
   
           chmod 755 "$FWPKGTMP"
           mv "$FWPKGTMP" "${DESTDIR}/var/db/pkg/${_pkgname}"
           unset FWPKGTMP
   }
   
   delete_firmware() {
           local _cwd _pkg="$1" _pkgdir="${DESTDIR}/var/db/pkg"
   
           # TODO: Check hash for files before deleting
           [ "$VERBOSE" -gt 2 ] && echo -n "Uninstall $_pkg ..."
           _cwd="${_pkgdir}/$_pkg"
   
           if [ ! -e "$_cwd/+CONTENTS" ] ||
               ! grep -Fxq '@option firmware' "$_cwd/+CONTENTS"; then
                   echo "${0##*/}: $_pkg does not appear to be firmware" >&2
                   return 2
         fi          fi
   
         doas -u "$_user" "$@"          set -A _remove -- "${_cwd}/+CONTENTS" "${_cwd}"
         _rc=$?  
   
         while doas -u "$_user" kill -9 -1 2>/dev/null; do          while read -r c g; do
                 echo "Processes still running for user $_user after: $@"                  case $c in
                 sleep 1                  @cwd) _cwd="${DESTDIR}$g"
                     ;;
                   @*) continue
                     ;;
                   *) set -A _remove -- "$_cwd/$c" "${_remove[@]}"
                     ;;
                   esac
           done < "${_pkgdir}/${_pkg}/+CONTENTS"
   
           # We specifically rm -f here because not removing files/dirs
           # is probably not worth failing over.
           for _r in "${_remove[@]}" ; do
                   if [ -d "$_r" ]; then
                           # Try hard not to actually remove recursively
                           # without rmdir on the install media.
                           set +o noglob
                           [ "$_r/*" = "$( echo "$_r"/* )" ] && rm -rf "$_r"
                           set -o noglob
                   else
                           rm -f "$_r"
                   fi
         done          done
   
         [[ -n $_file ]] && chown root "$_file"          [ "$VERBOSE" -gt 2 ] && echo " done."
   
         return $_rc          return 0
 }  }
   
 unpriv() {  usage() {
         do_as _sndio "$@"          echo "usage:  ${0##*/} [-d | -D] [-av] [-p path] [driver | file ...]"
           exit 2
 }  }
   
 unpriv2() {  ALL=false
         do_as _file "$@"  OPT_D=
 }  while getopts :adDnp:v name
   do
          case "$name" in
          a) ALL=true ;;
          d) DELETE=true ;;
          D) OPT_D=true ;;
          n) DRYRUN=true ;;
          p) LOCALSRC="$OPTARG" ;;
          v) VERBOSE=$(( VERBOSE + 1 )) ;;
          :)
              echo "${0##*/}: option requires an argument -- -$OPTARG" >&2
              usage 2
              ;;
          ?)
              echo "${0##*/}: unknown option -- -$OPTARG" >&2
              usage 2
              ;;
          esac
   done
   shift $((OPTIND - 1))
   
 _issue=  if [ "$LOCALSRC" ]; then
 fail() {          if [[ $LOCALSRC = @(ftp|http?(s))://* ]]; then
         echo $_issue >&2                  FWURL="${LOCALSRC}"
                   LOCALSRC=
           else
                   LOCALSRC="${LOCALSRC:#file:}"
                   ! [ -d "$LOCALSRC" ] &&
                       echo "The path must be a URL or an existing directory" >&2 &&
                       exit 2
           fi
   fi
   
   # "Download only" means local dir and don't install
   if [ "$OPT_D" ]; then
           INSTALL=false
           LOCALSRC="${LOCALSRC:-.}"
   elif [ "$LOCALSRC" ]; then
           DOWNLOAD=false
   fi
   
   if [ -x /usr/bin/id ] && [ "$(/usr/bin/id -u)" != 0 ]; then
           echo "need root privileges" >&2
         exit 1          exit 1
 }  fi
   
 VNAME=$(sysctl -n kern.osrelease)  set -sA devices -- "$@"
 VERSION="${VNAME%.*}${VNAME#*.}"  
 FWDIR="$VNAME"  
   
 # TODO: We need the firmware for the system we just installed  if "$DELETE"; then
 #       not the one we booted from.  For example:          [ "$OPT_D" ] && usage 22
 #       * booting from a snapshot bsd.rd that thinks it is the 7.0 release  
 #         will install the firmware from the 7.0 directory instead of  
 #         from the snapshots dir.  
 #       If they're using sysupgrade, then the installer kernel will be correct.  
 #       If we're doing this in the installer we can check what they picked  
 #       for downloading sets and use that value.  
 #       Otherwise, the fw_update after first boot will fix it up for us.  
   
 HTTP_FWDIR=$FWDIR          # Show the "Uninstalling" message when just deleting not upgrading
 set -- $(scan_dmesg "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p")          [ "$VERBOSE" -gt 0 ] && VERBOSE=3
 [[ $1 == -!(stable) ]] && HTTP_FWDIR=snapshots  
   
 FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}          set -A installed
 FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub          if [ "${devices[*]:-}" ]; then
 PKGDIR=${DESTDIR}/var/db/pkg                  "$ALL" && usage 22
 PATTERNS="file:${0%/*}/firmware_patterns"  
   
 fw_update() {                  set -A installed -- $(
         local _tmpsrc _f _remove _r                      for d in "${devices[@]}"; do
         local _src=$FWURL _t=Get _cfile="/tmp/SHA256" _srclocal=false                          f="${d##*/}"  # only care about the name
         local _drivers=$(                          f="${f%.tgz}" # allow specifying the package name
                 last=''                          [ "$( firmware_devicename "$f" )" = "$f" ] && f="$f-firmware"
                 ftp -D "Detecting" -Vmo- $PATTERNS |  
                 while read d m; do  
                         grep=grep  
                         [ "$last" = "$d" ] && continue  
                         [ "$m" ] || m="^$d[0-9][0-9]* at "  
                         [ "$m" = "${m#^}" ] && grep=fgrep  
                         $grep -q "$m" /var/run/dmesg.boot || continue  
                         echo $d  
                         last=$d  
                 done  
         )  
   
         if [ -z "$_drivers" ]; then                          set -A i -- $( installed_firmware '' "$f-" '*' )
                 echo "No devices found which need firmware files to be downloaded." >&2  
                 return                          if [ "${i[*]:-}" ]; then
                                   echo "${i[@]}"
                           else
                                   echo "No firmware found for '$d'" >&2
                           fi
                       done
                   )
           elif "$ALL"; then
                   set -A installed -- $( installed_firmware '*' '-firmware-' '*' )
         fi          fi
   
         if _tmpsrc=$( tmpdir "${DESTDIR}/tmp/fw_update" ); then          deleted=''
                 (          if [ "${installed:-}" ]; then
                 >$_tmpsrc/t &&                  for fw in "${installed[@]}"; do
                 $_unpriv cat $_tmpsrc/t                          if "$DRYRUN"; then
                 ) >/dev/null 2>&1 ||                                  [ "$VERBOSE" -gt 0 ] && echo "Delete $fw"
                     rm -r $_tmpsrc                          else
                                   delete_firmware "$fw" || continue
                           fi
                           deleted="$deleted,$( firmware_devicename "$fw" )"
                   done
         fi          fi
   
         [[ ! -d $_tmpsrc ]] &&          deleted="${deleted#,}"
                 _issue="Cannot create prefetch area" && fail          echo "${0:##*/}: deleted ${deleted:-none}";
   
         ! $_unpriv ftp -D "$_t" -Vmo - "$_src/SHA256.sig" >"$_cfile.sig" &&          exit
             _issue="Cannot fetch SHA256.sig" && fail  fi
   
         # Verify signature file with public keys.  if [ ! "$LOCALSRC" ]; then
         ! unpriv -f "$_cfile" \      LOCALSRC="$( tmpdir "${DESTDIR}/tmp/${0##*/}" )"
             signify -Vep $FWPUB_KEY -x "$_cfile.sig" -m "$_cfile" &&      REMOVE_LOCALSRC=true
             _issue="Signature check of SHA256.sig failed" && fail  fi
   
         for d in $_drivers; do  CFILE="$LOCALSRC/$CFILE"
                 _f=$( sed -n "s/.*(\($d-firmware-.*\.tgz\)).*/\1/p" "$_cfile" )  
                 installed=$( installed_firmware "$d" )  
   
                 for i in $installed; do  if [ "${devices[*]:-}" ]; then
                         if [ "$_f" = "$i.tgz" ]; then          "$ALL" && usage 22
                                 echo "Firmware for $d already installed ($installed)"  else
           [ "$VERBOSE" -gt 1 ] && echo -n "Detect firmware ..."
           set -sA devices -- $( detect_firmware )
           [ "$VERBOSE" -gt 1 ] &&
               { [ "${devices[*]:-}" ] && echo " found." || echo " done." ; }
   fi
   
   [ "${devices[*]:-}" ] || exit
   
   if "$DOWNLOAD"; then
           set +o noclobber # we want to get the latest CFILE
           fetch "$CFILE"
           set -o noclobber
           ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&
               echo "Signature check of SHA256.sig failed" >&2 && exit 1
   elif [ ! -e "$CFILE" ]; then
           # TODO: We shouldn't need a CFILE if all arguments are files.
           echo "${0##*/}: $CFILE: No such file or directory" >&2
           exit 2
   fi
   
   added=''
   updated=''
   kept=''
   for f in "${devices[@]}"; do
           d="$( firmware_devicename "$f" )"
   
           if [ "$f" = "$d" ]; then
                   f=$( firmware_filename "$d" || true )
                   [ "$f" ] || continue
                   f="$LOCALSRC/$f"
           elif ! "$INSTALL" && ! grep -Fq "($f)" "$CFILE" ; then
                   echo "Cannot download local file $f" >&2
                   exit 2
           fi
   
           set -A installed -- $( installed_firmware '' "$d-firmware-" '*' )
   
           if "$INSTALL" && [ "${installed[*]:-}" ]; then
                   for i in "${installed[@]}"; do
                           if [ "${f##*/}" = "$i.tgz" ]; then
                                   [ "$VERBOSE" -gt 2 ] && echo "Keep $i"
                                   kept="$kept,$d"
                                 continue 2                                  continue 2
                         fi                          fi
                 done                  done
           fi
   
                 rm -f /tmp/h /tmp/fail          if [ -e "$f" ]; then
                   if "$DOWNLOAD"; then
                 _t=Get/Verify                          [ "$VERBOSE" -gt 1 ] && ! "$INSTALL" &&
                 # Fetch firmware file and create a checksum by piping through                              echo "Keep/Verify ${f##*/}"
                 # sha256. Create a flag file in case ftp failed. Firmware                          "$DRYRUN"  || verify "$f" || continue
                 # from net is written to the prefetch area.                          "$INSTALL" || kept="$kept,$d"
                 ( $_unpriv ftp -D "$_t" -Vmo - "$_src/$_f" || >/tmp/fail ) |                  # else assume it was verified when downloaded
                 ( $_srclocal && unpriv2 sha256 -b >/tmp/h ||  
                     unpriv2 -f /tmp/h sha256 -bph /tmp/h >"$_tmpsrc/$_f" )  
   
                 # Handle failed transfer.  
                 if [[ -f /tmp/fail ]]; then  
                         rm -f "$_tmpsrc/$_f"  
                         _issue="Fetching of $_f failed!"  
                         fail  
                 fi                  fi
           elif "$DOWNLOAD"; then
                 # Verify firmware by comparing its checksum with SHA256.                  if "$DRYRUN"; then
                 if fgrep -qx "SHA256 ($_f) = $(</tmp/h)" "$_cfile"; then                          [ "$VERBOSE" -gt 0 ] && echo "Get/Verify ${f##*/}"
                         #_unver=$(rmel $_f $_unver)  
                         true  
                 else                  else
                         [[ -d "$_tmpsrc" ]] && rm -rf "$_tmpsrc"                          [ "$VERBOSE" -eq 1 ] && echo -n "Get/Verify ${f##*/} ..."
                         _issue="Checksum test for $_f failed."                          fetch  "$f" &&
                         fail                          verify "$f" ||
                               { [ "$VERBOSE" -eq 1 ] && echo " failed."; continue; }
                           [ "$VERBOSE" -eq 1 ] && ! "$INSTALL" && echo " done."
                 fi                  fi
                   "$INSTALL" || added="$added,$d"
           elif "$INSTALL"; then
                   echo "Cannot install ${f##*/}, not found" >&2
                   continue
           fi
   
                 # TODO: Check hash for files before deleting          "$INSTALL" || continue
                 if [ "$installed" ] && [ -e "${PKGDIR}/$installed/+CONTENTS" ]; then  
                         echo "Uninstalling $installed"  
                         cwd=${PKGDIR}/$installed  
   
                         set -A _remove -- "${cwd}/+CONTENTS" "${cwd}"          update=''
           if [ "${installed[*]:-}" ]; then
                   for i in "${installed[@]}"; do
                           "$DRYRUN" || delete_firmware "$i"
                           update="Update"
                   done
           fi
   
                         while read c g; do          "$DRYRUN" || add_firmware "$f" "$update"
                                 case $c in  
                                 @cwd) cwd="${DESTDIR}/$g"  
                                   ;;  
                                 @*) continue  
                                   ;;  
                                 *)  set -A _remove -- "$cwd/$c" "${_remove[@]}"  
                                   ;;  
                                 esac  
                         done < "${PKGDIR}/$installed/+CONTENTS"  
   
                         for _r in "${_remove[@]}" ; do          f="${f##*/}"
                                 if [ -d "$_r" ]; then          f="${f%.tgz}"
                                         # Try hard not to actually remove recursively          if [ "$update" ]; then
                                         # without rmdir on the install media.                  if [ "$VERBOSE" -eq 1 ] && "$DOWNLOAD" && ! "$DRYRUN"; then
                                         [ "$_r/*" = $( echo "$_r"/* ) ] && rm -rf "$_r"                          echo " updated."
                                 else                  elif [ "$VERBOSE" -eq 1 ]; then
                                         rm -f "$_r"                          echo "Update $f"
                                 fi                  elif [ "$VERBOSE" -gt 0 ] && "$DRYRUN"; then
                         done                          echo "Update $f"
                 fi                  fi
                   updated="$updated,$d"
           else
                   if [ "$VERBOSE" -eq 1 ] && "$DOWNLOAD" && ! "$DRYRUN"; then
                           echo " installed."
                   elif [ "$VERBOSE" -eq 1 ]; then
                           echo "Install $f"
                   elif [ "$VERBOSE" -gt 0 ] && "$DRYRUN"; then
                           echo "Install $f"
                   fi
                   added="$added,$d"
           fi
   done
   
         # TODO: Add some details about the install to +CONTENTS like pkg_add  added="${added:#,}"
         # TODO: Or, maybe we save the firmware someplace and make pkg_add reinstall  updated="${updated:#,}"
                 echo "Installing $_f"  kept="${kept:#,}"
                 tar -zxphf "$_tmpsrc/$_f" -C "${DESTDIR}/etc" "firmware/*"  if "$INSTALL"; then
                 mkdir -p ${PKGDIR}/${_f%.tgz}/          echo  "${0##*/}: added ${added:-none}; updated ${updated:-none}; kept ${kept:-none}"
                 tar -zxphf "$_tmpsrc/$_f" -C "${PKGDIR}/${_f%.tgz}" "+*"  else
                 ed -s "${PKGDIR}/${_f%.tgz}/+CONTENTS" <<EOL          echo  "${0##*/}: downloaded ${added:-none}; kept ${kept:-none}"
 /^@comment pkgpath/ -1a  fi
 @option manual-installation  
 @option firmware  
 @comment install-script  
 .  
 w  
 EOL  
         done  
 }  
   
 fw_update  

Legend:
Removed from v.1.14  
changed lines
  Added in v.1.141

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>